#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

unsigned int numblocks, tot_v = 0, tot_i = 0;
char defuser[] = "\\\\MSHOME\\Administrator";

struct vector3f
{
	float x,y,z; 
};

struct vector2f
{
	float tx,ty; 
};

struct ogf_bbox {
	struct vector3f		min;
	struct vector3f		max;
};

struct ogf_bsphere {
	struct vector3f		c;
	float			r;
};

struct ChunkIFF
{
	unsigned int type, size;
};

struct OGFVertex_v0 // x-ray actor_editor (0x00000112)
{
	struct vector3f p;
	struct vector3f n;
	float u,v;
};

struct OGFHeader_v4 // 0x2C (44)
{
 unsigned char format_version;
 unsigned char type;
 unsigned short shader_id;
 struct ogf_bbox		bb;
 struct ogf_bsphere	bs;
};

///////////////////////////////

#define MAX_OBJ_COUNT 1
#define MAX_TXT_COUNT 1

const char m_dds[] = "texture";
const char m_shd[] = "default";

OGFVertex_v0 * vtx;
unsigned short * idx;

unsigned int vcount;
unsigned int icount;
unsigned int bcount;

unsigned int vsize;
unsigned int isize;

vector3f cntr;
vector3f sz; // 1/2 of size!!!

  void make_verts(void)
  {
  unsigned int j = 0;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = -1.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = -1.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = -1.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = -1.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 1.0f;
  j++;

/////////////////////

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 1.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 1.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 1.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 1.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 1.0f;
  j++;

/////////////////////

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = -1.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 1.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 1.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 1.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = -1.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 1.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 1.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = 1.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = -1.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = -1.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = -1.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z - sz.z;
  vtx[j].n.x = 1.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 0.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = -1.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 0.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y - sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 0.0f;
  vtx[j].n.y = -1.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x - sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = -1.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 1.0f;
  j++;

  vtx[j].p.x = cntr.x + sz.x;
  vtx[j].p.y = cntr.y + sz.y;
  vtx[j].p.z = cntr.z + sz.z;
  vtx[j].n.x = 1.0f;
  vtx[j].n.y = 0.0f;
  vtx[j].n.z = 0.0f;
  vtx[j].u = 1.0f;
  vtx[j].v = 1.0f;
  j++;

	}

int main(int argc, char* argv[])
{
  unsigned int i, j;
	char fileName[256];
  FILE *outputFile;

 	printf("X-Ray ogf box_pattern maker [201108xx]\n");

	if (argc < 3) 
  {
  	printf("usage: make_ogf < boxes > < filename >\n\tb: boxes = b ^ 3\n\tfile: output ogf\n\n");
		return 1;
	}

  strcpy((char*)fileName,argv[2]);
  bcount = (unsigned int)atoi(argv[1]);
  vsize  = 24;
  isize  = 36;
  vcount = vsize * bcount * bcount * bcount;
  icount = isize * bcount * bcount * bcount;
	numblocks = bcount * bcount * bcount; // all in one block
	srand((unsigned)time(NULL));

  printf("creating %u boxes ... ",numblocks);

  vtx = new OGFVertex_v0[vsize];
  idx = new unsigned short[isize];

	unsigned int k = 0;
	j = 0;
  for (i = 0; i < 1; i++)
  {
  idx[j++] = 0;  idx[j++] = 2;  idx[j++] = 1;
  idx[j++] = 1;  idx[j++] = 2;  idx[j++] = 3;

  idx[j++] = 10;  idx[j++] = 14;  idx[j++] = 11;
  idx[j++] = 11;  idx[j++] = 14;  idx[j++] = 15;

  idx[j++] = 9;  idx[j++] = 19;  idx[j++] = 13;
  idx[j++] = 19;  idx[j++] = 23;  idx[j++] = 13;

  idx[j++] = 18;  idx[j++] = 12;  idx[j++] = 22;
  idx[j++] = 8;  idx[j++] = 12;  idx[j++] = 18;

  idx[j++] = 16;  idx[j++] = 17;  idx[j++] = 20;
  idx[j++] = 17;  idx[j++] = 21;  idx[j++] = 20;

  idx[j++] = 4;  idx[j++] = 5;  idx[j++] = 7;
  idx[j++] = 4;  idx[j++] = 7;  idx[j++] = 6;
	}

  printf("DONE\n");
  printf("creating '%s'\n",fileName);

  outputFile = fopen(fileName,"wb");


  ChunkIFF * ih = new ChunkIFF;
  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  OGFHeader_v4 * hdr4 = new OGFHeader_v4;
  hdr4->format_version = 4;
  hdr4->type = 1;
  hdr4->shader_id = 0;
  hdr4->bb.min.x = -500.0f;
  hdr4->bb.min.y = -500.0f;
  hdr4->bb.min.z = -500.0f;
  hdr4->bb.max.x = 500.0f;
  hdr4->bb.max.y = 500.0f;
  hdr4->bb.max.z = 500.0f;
  hdr4->bs.c.x = 0.0f;
  hdr4->bs.c.y = 0.0f;
  hdr4->bs.c.z = 0.0f;
  hdr4->bs.r = 500.0f;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

  ih->type = 0x12; // text info
  ih->size = 0x6E; // guessed :)
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  i = 0; 
  fputs("test_level\\test_level.object",outputFile);
  fwrite(&i,1,1,outputFile); 
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time
  fputs(defuser,outputFile); fwrite(&i,1,1,outputFile); 
  fwrite(&i,4,1,outputFile); // fake time


  ih->type = 0x09; // childrens
  ih->size = 0;
	for (j = 0;j < numblocks; j++)
  ih->size += 8 + (8+sizeof(OGFHeader_v4))+((strlen(m_dds) + strlen(m_shd) + 0x02)+8)+(8+((vsize*sizeof(OGFVertex_v0))+8))+(8+((isize*2)+4));
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

  printf("making %u blocks\n",numblocks);

	unsigned int bline = bcount;
  float bstep = (40.0f/((bline << 1) + (bline-1)));
  cntr.x = -20.0f+bstep;
  cntr.y = -20.0f+bstep;
  cntr.z = -20.0f+bstep;
	sz.x = sz.y = sz.z = bstep;

  k = 0;
	for (j = 0;j < numblocks; j++)
	{
	printf("child %u\n",k);
	// child start

  ih->type = k; // children #j
  ih->size = (8+sizeof(OGFHeader_v4))+((strlen(m_dds) + strlen(m_shd) + 0x02)+8)+(8+((vsize*sizeof(OGFVertex_v0))+8))+(8+((isize*2)+4));
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);

	make_verts();

  ih->type = 0x01; // header
  ih->size = sizeof(OGFHeader_v4);
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
  hdr4->format_version = 4;
  hdr4->type = 0;
  hdr4->shader_id = 0;
  hdr4->bb.min.x = cntr.x - sz.x;
  hdr4->bb.min.y = cntr.y - sz.y;
  hdr4->bb.min.z = cntr.z - sz.z;
  hdr4->bb.max.x = cntr.x + sz.x;
  hdr4->bb.max.y = cntr.y + sz.y;
  hdr4->bb.max.z = cntr.z + sz.z;
  hdr4->bs.c.x = cntr.x;
  hdr4->bs.c.y = cntr.y;
  hdr4->bs.c.z = cntr.z;
  hdr4->bs.r = (sz.x + sz.y + sz.z) / 3;
	fwrite(hdr4,sizeof(OGFHeader_v4),1,outputFile);

	printf(" blks: '%s'",m_dds);
  ih->type = 0x02; // texture
  ih->size = strlen(m_dds) + strlen(m_shd) + 0x02; 
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0;
  fputs(m_dds,outputFile); fwrite(&i,1,1,outputFile); 
  fputs(m_shd,outputFile); fwrite(&i,1,1,outputFile); 

	printf(" v %u",vsize); tot_v += vsize;
  ih->type = 0x03; // verts
  ih->size = (vsize*sizeof(OGFVertex_v0))+8;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = 0x00000112; // D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1
  fwrite(&i,4,1,outputFile);
	i = vsize; 
  fwrite(&i,4,1,outputFile);
	fwrite(vtx,sizeof(OGFVertex_v0),i,outputFile);
	
	printf(" i %u\n",isize); tot_i += isize;
  ih->type = 0x04; // idx
  ih->size = (isize*2)+4;
	fwrite(ih,sizeof(ChunkIFF),1,outputFile);
	i = isize; 
  fwrite(&i,4,1,outputFile);
	fwrite(idx,sizeof(unsigned short),i,outputFile);

	k++;

	cntr.x += bstep*3; 
	if (cntr.x > 20.0f) { cntr.x = -20.0f + bstep; cntr.y += bstep*3; }
	if (cntr.y > 20.0f) { cntr.x = cntr.y = -20.0f + bstep; cntr.z += bstep*3; }

	// child end 
	}

  delete [] vtx;
  delete [] idx;

  if (outputFile) fclose(outputFile);
  printf("writing '%s' [%u,%u] OK\n",fileName,tot_v,tot_i);
///////////////////////////////////////

	return 0;
	}
